package actions;

import java.awt.event.ActionEvent;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

import javax.swing.AbstractAction;
import javax.swing.JButton;

import socket.ClientSocketManager;
import chatA2.ChatA2app;
import chatA2.ConfigurationState;

public class ConnectServerAction extends AbstractAction {

	private static ConnectServerAction instance = null;
	
	public static ConnectServerAction getInstance()
	{
		if( instance == null ) instance = new ConnectServerAction();
		
		return instance;
	}
	
	protected ConnectServerAction()
	{
		super( "Connect to server" );
	}
	
	public void actionPerformed( ActionEvent arg0 ) {
		
		if ( ConfigurationState.getInstance().isClient_connected() == false ) {
   			
	   		 // Start the server
			
			 ConfigurationState.getInstance().setUserMode(true);
			 ChatA2app.getInstance().nick_name_field.setEditable(false);
			 //ClientSocketManager.getInstance().start();	
			 
			 try {
					
					ChatA2app.getInstance().c_socket = new Socket(ChatA2app.getInstance().server_ip.getText(), Integer.parseInt(ChatA2app.getInstance().server_port.getText()));
					
					ChatA2app.getInstance().c_os = ChatA2app.getInstance().c_socket.getOutputStream();
					ChatA2app.getInstance().c_is = ChatA2app.getInstance().c_socket.getInputStream();
					
					ChatA2app.getInstance().c_dis = new DataInputStream(ChatA2app.getInstance().c_is);
					ChatA2app.getInstance().c_dos = new DataOutputStream(ChatA2app.getInstance().c_os);
					
				//	Change client status
		   			ConfigurationState.getInstance().setClient_connected(true);
		   			
		        //  Set the text for CONNECT	
		   			ChatA2app.getInstance().c_dos.writeBytes(ChatA2app.getInstance().nick_name_field.getText() + "\n");
		   		    ChatA2app.getInstance().client_status_label.setText("Client is connected to the server");
		  		    ChatA2app.getInstance().start_server.setEnabled(false);
		   			ChatA2app.getInstance().logArea.append("Client is connected to the server!\n");
		   			        
					
				} catch (UnknownHostException e) {
					ChatA2app.getInstance().logArea.append("Error: Unknown Host\n");
				} catch (IOException e) {
					ChatA2app.getInstance().logArea.append("Error: IO Exception\n");
				}
			 
			 ChatA2app.getInstance().ClientSocketManager = new ClientSocketManager();
			 ChatA2app.getInstance().ClientSocketManager.start();
	   		
		if( arg0.getSource() instanceof JButton )
		{
			JButton button = (JButton) arg0.getSource();
			button.setAction( DisconnectServerAction.getInstance() );
		}
		
	  }
		
	}

	

}
