package actions;


import java.awt.event.ActionEvent;
import java.io.IOException;

import javax.swing.AbstractAction;
import javax.swing.JButton;

import socket.ClientSocketManager;

import chatA2.ChatA2app;
import chatA2.ChatWriter;
import chatA2.ConfigurationState;


public class DisconnectServerAction extends AbstractAction {

	private static DisconnectServerAction instance = null;
	
	
	public static DisconnectServerAction getInstance()
	{
		if( instance == null ) instance = new DisconnectServerAction();
		
		return instance;
	}
	
	
	protected DisconnectServerAction()
	{
		super( "Disconnect from server" );
	}
	
	
	public void actionPerformed(ActionEvent arg0) {
		
		
             //	 Change status
	
			 ChatWriter.getInstance().write_msg("C01" + ChatA2app.getInstance().nick_name_field.getText());
			 ConfigurationState.getInstance().setClient_connected(false);
			 
			 //   Set GUI
			 
			 ChatA2app.getInstance().nick_name_field.setEditable(true);
			 ChatA2app.getInstance().client_status_label.setText("Client is not connected");
			 ChatA2app.getInstance().start_server.setEnabled(true);
			 ChatA2app.getInstance().logArea.append("Client disconnected from server!\n");
			 
			 //	 Close Thread
			 
			 ChatA2app.getInstance().ClientSocketManager.stop();
			 
             //	Close the input stream, output stream and client socket
			   
			   try {
					ChatA2app.getInstance().c_dis.close();
					ChatA2app.getInstance().c_dos.close();
					ChatA2app.getInstance().c_socket.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			 	
			 
			 // Change Action
		
		     if( arg0.getSource() instanceof JButton ) {
		    	 JButton button = (JButton) arg0.getSource();
		    	 button.setAction( ConnectServerAction.getInstance() );
		     }
		
	}
	

}
