package actions;

import java.awt.event.ActionEvent;
import java.io.IOException;

import javax.swing.AbstractAction;
import javax.swing.JButton;

import socket.SocketManager;

import chatA2.ChatA2app;
import chatA2.Chatter;
import chatA2.ConfigurationState;

public class StopServerAction extends AbstractAction {
	
	private static StopServerAction instance = null;
	
	public static StopServerAction getInstance()
	{
		if( instance == null ) instance = new StopServerAction();
		
		return instance;
	}
	
	protected StopServerAction()
	{
		super( "Stop server" );
	}
	
	public void actionPerformed(ActionEvent arg0) {
		
      //  Change server status
		ConfigurationState.getInstance().setServer_connected(false);
		
		ChatA2app.getInstance().nick_name_field.setEditable(true);
		
	 // Stop the server
	 try {
		 
		 for ( int i = 1; i <= ChatA2app.getInstance().chatters; i ++ ) {
			 ( (Chatter) ( ChatA2app.getInstance().chatterList.elementAt(i - 1) )).clientUserSocket.stop();
			 ( (Chatter) ( ChatA2app.getInstance().chatterList.elementAt(i - 1) )).dos.close();
			 ( (Chatter) ( ChatA2app.getInstance().chatterList.elementAt(i - 1) )).dis.close();
			 ( (Chatter) ( ChatA2app.getInstance().chatterList.elementAt(i - 1) )).client_socket.close();
		 }
		 
		 ChatA2app.getInstance().chatterList.removeAllElements();
		 ChatA2app.getInstance().chatters = 0;
		 ChatA2app.getInstance().socketManager.stop();
		 ChatA2app.getInstance().serverSocket.close();
		 
	} catch (IOException e1) {
		System.out.println("I/O Error: can't stop SocketManager Thread or close server socket.");
	}	
		
     // Set the text for STOP		
	 ChatA2app.getInstance().server_status_label.setText("Server is not active");
	 ChatA2app.getInstance().connect_server.setEnabled(true);
	 ChatA2app.getInstance().logArea.append("Server stopped!\n");
		
		
		if( arg0.getSource() instanceof JButton )
		{
			JButton button = (JButton) arg0.getSource();
			button.setAction( StartServerAction.getInstance() );
		}
		
	}

}
