package actions;

import java.awt.event.ActionEvent;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

import javax.swing.AbstractAction;
import javax.swing.JButton;

import socket.SocketManager;

import chatA2.ChatA2app;
import chatA2.ConfigurationState;

public class StartServerAction extends AbstractAction {
		
	private static StartServerAction instance = null;
	
	public static StartServerAction getInstance()
	{
		if( instance == null ) instance = new StartServerAction();
		
		return instance;
	}
	
	protected StartServerAction()
	{
		super( "Start server" );
	}
	
	public void actionPerformed(ActionEvent arg0) {
		
		if (ConfigurationState.getInstance().isServer_connected() == false) {
 			
			    ConfigurationState.getInstance().setUserMode(false);
			    ChatA2app.getInstance().nick_name_field.setEditable(false);
			    
			    
			    // Start the server
				
				 try {
					 
					ChatA2app.getInstance().serverSocket = new ServerSocket(Integer.parseInt(ChatA2app.getInstance().port.getText()));
					
		        //Change server status
					ConfigurationState.getInstance().setServer_connected(true);
					
		        //Set the text for START	
					ChatA2app.getInstance().server_status_label.setText("Server is active");
					ChatA2app.getInstance().connect_server.setEnabled(false);
					ChatA2app.getInstance().logArea.append("Server started!\n");
					
				} catch (NumberFormatException e1) {
					ChatA2app.getInstance().logArea.append("Error: number format exception. I can't start the server\n");
				} catch (IOException e1) {
					ChatA2app.getInstance().logArea.append("Error: IO exception. I can't start the server\n");
				}	
			    
				//SocketManager.getInstance().start();
				ChatA2app.getInstance().socketManager = new SocketManager();
				ChatA2app.getInstance().socketManager.start();
			
		
		if( arg0.getSource() instanceof JButton ) {
			JButton button = (JButton) arg0.getSource();
			button.setAction( StopServerAction.getInstance() );
			
		}
		
	  }
		
	}

	

}
