package chatA2;

import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.event.EventListenerList;

import socket.SocketManager;

import actions.ConnectServerAction;
import actions.SendMsgAction;
import actions.StartServerAction;

public class ChatA2app implements Runnable {
	
	public JTextField port = null;
	public JTextArea logArea = null;
	public JLabel server_status_label = null;
	public JButton connect_server = null;
	public JButton start_server = null;
	public JLabel client_status_label = null;
	public JTextField server_ip = null;
	public JTextField server_port = null;
	public JTextArea chatArea = null;
	public JTextField message_field = null;
	public JTextField nick_name_field = null;
	
	public Thread ClientSocketManager = null;
	
	public Socket c_socket = null;
	public InputStream c_is = null;
	public OutputStream c_os = null;
	public DataInputStream c_dis = null;
	public DataOutputStream c_dos = null;
	
	public ServerSocket serverSocket = null;
	public SocketManager socketManager = null;
	
	public int chatters = 0;
	public Vector chatterList = new Vector();
	
	private static ChatA2app instance = null;
	
	
	public static ChatA2app getInstance() {
		if (instance == null) {
			instance = new ChatA2app();
		}
		return instance;
	}
	
	
	public void run() {
		
		  // Creating the main window of the application.
		  JFrame main_window = new JFrame("ChatA2");
		  main_window.setLayout(new BoxLayout(main_window.getContentPane(), 1));
		  main_window.setBounds(200, 200, 400, 450);

		  // Creating the TabbedPane that include all other components.
		  JTabbedPane tabbedPane = new JTabbedPane();
		  main_window.getContentPane().add(tabbedPane);

		  // Creating the Configuration Panel.
		  JPanel configuration_panel = new JPanel();

		  // Creating the Server Mode Panel.
		  JPanel server_mode = new JPanel();
		  server_mode.setBorder(BorderFactory.createTitledBorder("Server Mode"));
		  server_mode.setLayout(new BoxLayout(server_mode, 0));
		  server_mode.setPreferredSize(new Dimension(380, 100));
		  configuration_panel.add(server_mode);
		  JPanel server_mode_sx = new JPanel();
		  server_mode_sx.setLayout(new BoxLayout(server_mode_sx, 1));
		  server_mode.add(server_mode_sx);
		  JPanel server_mode_dx = new JPanel();
		  server_mode_dx.setLayout(new BoxLayout(server_mode_dx, 1));
		  server_mode.add(server_mode_dx);
		  JLabel your_ip_label = new JLabel("Your IP is");
		  server_mode_sx.add(your_ip_label);
		  try {
			  InetAddress my_host = InetAddress.getLocalHost();
			  JTextField your_ip = new JTextField(my_host.getHostAddress());
			  your_ip.setMaximumSize(new Dimension(250, 20));
			  your_ip.setEditable(false);
			  server_mode_sx.add(your_ip);
		  } 
		  catch (UnknownHostException e) {
			e.printStackTrace();
		  }
		  JLabel port_label = new JLabel("Port");
		  server_mode_sx.add(port_label);
		  port = new JTextField("5000");
		  port.setMaximumSize(new Dimension(250, 20));
		  server_mode_sx.add(port);
		  start_server = new JButton( StartServerAction.getInstance() );
		  server_mode_dx.add(start_server);
		  server_mode_dx.add(Box.createRigidArea(new Dimension(0, 16)));
		  server_status_label = new JLabel("Server is not active");
		  server_mode_dx.add(server_status_label);
		  
		  // Creating ClientPanel
		  JPanel clientPanel = new JPanel();
		  clientPanel.setBorder(BorderFactory.createTitledBorder("Client Mode"));
		  clientPanel.setLayout(new BoxLayout(clientPanel, 0));
		  clientPanel.setPreferredSize(new Dimension(380, 100));
		  configuration_panel.add(clientPanel);
		  JPanel clientPanel_sx = new JPanel();
		  clientPanel_sx.setLayout(new BoxLayout(clientPanel_sx, 1));
		  clientPanel.add(clientPanel_sx);
		  JPanel clientPanel_dx = new JPanel();
		  clientPanel_dx.setLayout(new BoxLayout(clientPanel_dx, 1));
		  clientPanel.add(clientPanel_dx);
		  JLabel server_ip_label = new JLabel("Server IP");
		  clientPanel_sx.add(server_ip_label);
		  server_ip = new JTextField("127.0.0.1");
		  server_ip.setMaximumSize(new Dimension(250, 20));
		  clientPanel_sx.add(server_ip);
		  JLabel server_port_label = new JLabel("Server port");
		  clientPanel_sx.add(server_port_label);
		  server_port = new JTextField("5000");
		  server_port.setMaximumSize(new Dimension(250, 20));
		  clientPanel_sx.add(server_port);
		  connect_server = new JButton( ConnectServerAction.getInstance() );
		  clientPanel_dx.add(connect_server);
		  clientPanel_dx.add(Box.createRigidArea(new Dimension(0, 16)));
		  client_status_label = new JLabel("Client is not connected");
		  clientPanel_dx.add(client_status_label);
		  
		  // Creating Log Panel
		  JPanel logPanel = new JPanel();
		  logPanel.setBorder(BorderFactory.createTitledBorder("Status Log"));
		  logPanel.setLayout(new BoxLayout(logPanel, 0));
		  logPanel.setPreferredSize(new Dimension(380, 100));
		  configuration_panel.add(logPanel);
		  logArea = new JTextArea();
		  logArea.setEditable(false);
		  JScrollPane logScroll = new JScrollPane(logArea);
		  logPanel.add(logScroll);
		  
          // Creating UserInfo
		  JPanel userInfoPanel = new JPanel();
		  userInfoPanel.setBorder(BorderFactory.createTitledBorder("User Info"));
		  userInfoPanel.setLayout(new BoxLayout(userInfoPanel, 0));
		  userInfoPanel.setPreferredSize(new Dimension(380, 50));
		  configuration_panel.add(userInfoPanel);
		  JLabel nick_name_label = new JLabel("Your NickName");
		  userInfoPanel.add(nick_name_label);
		  userInfoPanel.add(Box.createRigidArea(new Dimension(5, 0)));
		  int user_random_number = (int) (Math.random() * 100);
		  nick_name_field = new JTextField("User_" + user_random_number);
		  nick_name_field.setMaximumSize(new Dimension(100, 20));
		  userInfoPanel.add(nick_name_field);
		  		  
		  
		  // Creating the Chat Panel.
		  JPanel chat_panel = new JPanel();
		  chat_panel.setLayout(new BoxLayout(chat_panel, 1));
		  JPanel chat_area_panel = new JPanel();
		  chat_area_panel.setBorder(BorderFactory.createTitledBorder("Chat Area"));
		  chat_area_panel.setLayout(new BoxLayout(chat_area_panel, 1));
		  chat_area_panel.setPreferredSize(new Dimension(380, 100));
		  chatArea = new JTextArea();
		  chatArea.setEditable(false);
		  JScrollPane chatAreaScroll = new JScrollPane(chatArea);
		  chatAreaScroll.setPreferredSize(new Dimension(380, 100));
		  chat_area_panel.add(chatAreaScroll);
		  chat_panel.add(chat_area_panel);
		  JPanel send_msg_panel = new JPanel();
		  send_msg_panel.setLayout(new BoxLayout(send_msg_panel, 0));
		  send_msg_panel.setPreferredSize(new Dimension(380, 50));
		  send_msg_panel.setBorder(BorderFactory.createTitledBorder("Message Panel"));
		  message_field = new JTextField();
		  message_field.setMaximumSize(new Dimension(275, 20));
		  send_msg_panel.add(message_field);
		  send_msg_panel.add(Box.createRigidArea(new Dimension(5, 0)));
		  JButton send_msg_button = new JButton( SendMsgAction.getInstance() );;
		  send_msg_button.setMaximumSize(new Dimension(100, 20));
		  send_msg_panel.add(send_msg_button);
		  chat_panel.add(send_msg_panel);

		  
		  //Adding main panels to the Tab.
		  tabbedPane.addTab("Configuration Panel", configuration_panel);
		  tabbedPane.addTab("Chat Panel", chat_panel);

		  // We can now see program's GUI.
		  main_window.setVisible(true);
		
	}

}
