package chatA2;

import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.Vector;

import socket.ClientSocketManager;
import socket.clientUserSocket;

public class ChatWriter {
	
	private static ChatWriter instance = null;
	
	public static ChatWriter getInstance() {
		if (instance == null) {
			instance = new ChatWriter();
		}
		return instance;
	}
	
	public synchronized void write_msg(String msg) {
		
		if ( ConfigurationState.getInstance().get_user_mode() && ConfigurationState.getInstance().isClient_connected()) {
		
			try {
				ChatA2app.getInstance().c_dos.writeBytes(msg);
			} catch (IOException e) {
				ChatA2app.getInstance().logArea.append("Error: IO Exception\n");
			}
			
		} else if ( ConfigurationState.getInstance().isServer_connected() ) {
			
			ChatA2app.getInstance().chatArea.append(msg.substring(1));
			
			
			for( int i = 1; i <= ChatA2app.getInstance().chatters; i++ ) {
		        try {
		        	((Chatter) ( ChatA2app.getInstance().chatterList.elementAt(i - 1) )).dos.writeBytes(msg);
				} catch (IOException e) {
					e.printStackTrace();
				}
		    }
			
		}
		
		ChatA2app.getInstance().message_field.setText("");
		ChatA2app.getInstance().message_field.grabFocus();
		
	}
	
	public synchronized void addChatter(DataOutputStream dos, clientUserSocket clientUserSocket, DataInputStream dis, Socket client_socket, String nick_name) {
		
		ChatA2app.getInstance().chatters = ChatA2app.getInstance().chatters + 1;
		ChatA2app.getInstance().chatterList.addElement( new Chatter(dos, clientUserSocket, dis, client_socket, nick_name) );
				
	}
	
    public synchronized void clientControlManager(String msg) {
		
     int cmd_n = Integer.parseInt(msg.substring(0, 2));
     String nick_name = null;
     
		switch ( cmd_n ) {
			case 01 :
				nick_name = msg.substring(2);
				ChatWriter.getInstance().write_msg("T*** " + nick_name + " *** exits the chat\n");
				break;
		}
				
	}
    
    public synchronized void serverControlManager(String msg) {
		
		int cmd_n = Integer.parseInt(msg.substring(0, 2));
		int chatter_index = 0;
		String nick_name = msg.substring(2);
		
		switch ( cmd_n ) {
			case 01 :
				try {
				for ( int i = 1; i <= ChatA2app.getInstance().chatters; i ++ ) {
					if ( (( Chatter ) ( ChatA2app.getInstance().chatterList.elementAt( i - 1 ) )).nick_name.compareTo( nick_name ) == 0 ) {
						(( Chatter ) ( ChatA2app.getInstance().chatterList.elementAt( i - 1 ) )).clientUserSocket.stop();
						(( Chatter ) ( ChatA2app.getInstance().chatterList.elementAt( i - 1 ) )).dos.close();
						(( Chatter ) ( ChatA2app.getInstance().chatterList.elementAt( i - 1 ) )).dis.close();
						(( Chatter ) ( ChatA2app.getInstance().chatterList.elementAt( i - 1 ) )).client_socket.close();
						ChatA2app.getInstance().chatterList.remove( i - 1 );
						ChatWriter.getInstance().write_msg("C01" + nick_name);
						break;
					}
				}
				} catch (IOException e) {
					e.printStackTrace();
					System.out.println("I/O Error: can't erase this user from the server, ChatWriter:97 ");
				}
				ChatA2app.getInstance().logArea.append("Client " + nick_name + " disconnected from server!\n");
				break;
		}
				
	}

}
